#include "CC.h"

void DrawGadgetBox(int x, int y, int w, int h)
{
	int u,v;
	SDL_Rect r;
	
	r.x=x-EDGE;
	r.y=y-EDGE;
	r.w=w+EDGE*2;
	r.h=h+EDGE*2;
	SDL_BlitSurface(ccgadget[0],&r,s,&r);

	for(v=0; v<h+EDGE*2; v++)
	{
		u=(v<h/2?
			w-v+EDGE*2:
			h-v+EDGE*2);
		r.x=x-EDGE;
		r.y=y+v-EDGE;
		r.w=u;
		r.h=1;
		SDL_BlitSurface(ccgadget[2],&r,s,&r);
	}

	if(h>2)
	{
		r.x=x;
		r.y=y;
		r.w=w;
		r.h=h;
		SDL_BlitSurface(ccgadget[1],&r,s,&r);
	}
}

void DrawInvGadgetBox(int x, int y, int w, int h)
{
	int u,v;
	SDL_Rect r;
	
	r.x=x-EDGE;
	r.y=y-EDGE;
	r.w=w+EDGE*2;
	r.h=h+EDGE*2;
	SDL_BlitSurface(ccgadget[2],&r,s,&r);

	for(v=0; v<h+EDGE*2; v++)
	{
		u=(v<(h+EDGE*2)/2?
			w-v+EDGE*2:
			h-v+EDGE*2);
		r.x=x-EDGE;
		r.y=y+v-EDGE;
		r.w=u;
		r.h=1;
		SDL_BlitSurface(ccgadget[1],&r,s,&r);
	}

	if(h>2)
	{
		r.x=x;
		r.y=y;
		r.w=w;
		r.h=h;
		SDL_BlitSurface(ccgadget[1],&r,s,&r);
	}
}
