#ifndef font_h
#define font_h

#include <stdarg.h>

#include "jasdl.h"

/* types */

typedef SDL_Surface* JASDL_Font[62];

/* functions */

JASDL_Font *JASDLFont_Create(SDL_Surface *src);
void JASDLFont_DisplayFormatAlpha(JASDL_Font *src);

SDL_Surface *JASDLFont_GetChar(JASDL_Font *font, Uint8 c);
int JASDLFont_Width(JASDL_Font *font, char *str);
#define JASDLFont_Height(font) ((*(font))[0]->h)

void JASDLFont_putc(JASDL_Font *font, SDL_Rect *dst, Uint8 c);
void JASDLFont_puts(JASDL_Font *font, int x, int y, char *str);
void JASDLFont_vprintf(JASDL_Font *font, int x, int y, char *format, va_list ap);
void JASDLFont_printf(JASDL_Font *font, int x, int y, char *format, ...);

#endif
