#include "CC.h"

#define INNER_EDGE	2
#define INTABS(a)	(a<0?(-(a)):(a))

void gameover(int player)
{
	int GO_X,GO_Y,GO_H,GO_W,w,th,y,plyr;
	char str[80], anyhumans=0, humanwins=0;
	Uint32 black;
	
	black=SDL_MapRGB(s->format,0,0,0);
	clear_hotspots();
	th=text_height();
	GO_W=text_width("Game Over")+2;
	plyr=positions[numplayers-1][INTABS(player)-1]+1;
	sprintf(str,"Player %d %s",plyr,(player>0?"Won!":"Forfeited!"));
	w=text_width(str);
	GO_W=(w>GO_W?w:GO_W)+INNER_EDGE*2;
	GO_H=th*2+4+EDGE*2+4+th;
	GO_X=0;//ccboard->w/2-(GO_W/2);
	GO_Y=s->h-GO_H-EDGE;//ccboard->h/2-(GO_H/2);
	DrawGadgetBox(GO_X,GO_Y,GO_W,GO_H);
	y=GO_Y+th+INNER_EDGE;
	/*
	DrawGadget(1,4,
		GO_X+INNER_EDGE,		y,
		GO_X+GO_W-INNER_EDGE,	y,
		GO_X+GO_W-INNER_EDGE,	y+1,
		GO_X+INNER_EDGE,		y+1);
	DrawGadget(3,4,
		GO_X+INNER_EDGE,		y+1,
		GO_X+GO_W-INNER_EDGE,	y+1,
		GO_X+GO_W-INNER_EDGE,	y+2,
		GO_X+INNER_EDGE,		y+2);
	*/
	y=GO_Y;
	textoc_print(0,y,GO_W+INNER_EDGE/*ccboard->w*/,"Game Over");
	y+=2+th+2;
	text_print(GO_X+INNER_EDGE,y,str);
	y+=th+2;
	SizeButtons(BU_H,2,GO_buttons,&w,NULL);
	DrawButtons(BU_H,2,GO_buttons, GO_W/2-w/2/*ccboard->w/2-w/2*/,y);
	UpdateWin(0);

	for(y=0; y<numplayers && !anyhumans; y++)
		if(!strcmp(players[playerlist[y]].name,"Human"))
			anyhumans=1;
	humanwins=(!strcmp(players[playerlist[plyr-1]].name,"Human") && player>0);

	if(humanwins)
		playsound(4);
	else if(player<0)
		playsound(0);
	else if(anyhumans)
		playsound(1);
	else
		playsound(6);
	if(anyhumans)
	{
		if(humanwins)
			Mix_PlayMusic(music[3],2);
		else
			Mix_PlayMusic(music[2],2);
	}
	else
		Mix_PlayMusic(music[4],0);
		
	
	{
		float a=0,aa=33*RADIAN;
		int i,c=games[numplayers-1][plyr-1]-1;
		char *name=players[playerlist[plyr-1]].name;
		SDL_Rect r={GO_X-EDGE,GO_Y-EDGE,GO_W+EDGE*2,GO_H+EDGE*2};
		
		w=text_width(name)/2;
		SDL_BlitSurface(s,NULL,winbuf,NULL);
		while (!quit && !newgame)
		{
			if(!Mix_PlayingMusic())
				Mix_PlayMusic(music[1],-1);
			JASDL_EventPollLoop(); /* menu only */
			if(player>0)
			{
				SDL_BlitSurface(winbuf,NULL,s,NULL);
				for(i=0;i<181;i++)
				{
					PutMarble(c,
							cos(a+i*RADIAN*4)*s->w/2+s->w/2,
							sin((a+aa)+i*RADIAN*5)*s->h/2+s->h/2);
				}
				for(i=0;i<181;i+=15)
				{
					text_print(cos(a+i*RADIAN*4)*s->w/2+s->w/2-w,
							sin(aa+i*RADIAN*5)*s->h/2+s->h/2,
							name);
				}
				a=fmod(a+RADIAN,360);
				aa=fmod(aa+RADIAN,360);
				SDL_BlitSurface(winbuf,&r,s,&r);
				UpdateWin(0);
			}
		}
	}

	Mix_FadeOutMusic(3000);
	
	clear_hotspots();

	SDL_BlitSurface(s,NULL,winbuf,NULL);
	for(y=0;y<s->h;y+=10)
	{
		SDL_Rect r;
		
		r.x=0;
		r.y=-y;
		SDL_FillRect(s,NULL,black);
		SDL_BlitSurface(winbuf,NULL,s,&r);
		UpdateWin(0);
	}
}
