#include "CC.h"

void Xfindalljumps(int);
void Xallslides(int);
int inarr(int, int*);
void findjump(int, int);
int slide(int, int, int, int);
void Xerrprint(int);
void Xstatprint(int);
void Xclrerror(void);
#define clearB() memset(B,0,121)

int found;
char B[121];

int humanX(PlayerState *ps, int player, int status, int error)
{
	char str[80];
	int w;
	int c[2],r[2];

	//oldwinbuf=winbuf;
	//winbuf=newwinbuf;
	SDL_BlitSurface(s,NULL,oldwinbuf,NULL);
	clearB();
	UpdateWin(1);
	sprintf(str,"%d",player);
	w=text_width("Player")+2+text_width(str)+2+MARBLE_W+2;
	DrawGadgetBox(0,0,w,MARBLE_H);
	/*Xstatprint(status);*/
	w=texto_print(1,1,"Player")+2;
	w+=text_print(w,1,str)+2;
	PutMarble(player-1,w+2,2);
	UpdateWin(0);
	m[0]=m[1]=m[2]= -1;
	while(m[1]<0 || m[0]<0)
	{
		button=0;
		while (!button && !quit && !newgame)
			getclick(-3); /* button or menu */
		if (button)
		{
			c[1]=XtoC(mouseX);
			r[1]=YtoR(mouseY);
			m[1]=fromrc(r[1],c[1]);
			if(m[1]>-1 && (b[m[1]] || m[0]<0))
			{
				if(b[m[1]]==player)
				{
					outlineMoves(0, player);
					clearB();
					if(m[0]!=m[1])
					{
						playsound(2);
						c[0]=XtoC(mouseX);
						r[0]=YtoR(mouseY);
						m[0]=fromrc(r[0],c[0]);
						if(!hints)
							outlineMoves(1, player);
						Xfindalljumps(m[0]);
						Xallslides(m[0]);
						if (hints)
							outlineMoves(1, player);
					}
					else
					{
						if(m[0]>-1)
							playsound(3);
						m[0]= -1;
					}
				}
				m[1]= -1;
			}
			else
			{
				if (m[0]!=-1 && B[fromrc(r[1],c[1])])
				{
					playsound(2);
					m[1]=fromrc(r[1],c[1]);
				}
				else
				{
					if(m[1]>-1 && m[0]>-1)
						playsound(3);
					m[1]= -1;
				}
			}
		}
		else
		{
			outlineMoves(0, player);
			return(2);
		}
	}
	outlineMoves(0, player);
	found=0;
	m[0]=fromrc(r[0],c[0]);
	m[1]=-1;
	m[2]=-1;
	/*check if slide...if not then find the jump*/
	if (!slide(r[0],c[0],r[1],c[1]))
		findjump(1,fromrc(r[1],c[1]));
	else
		m[1]=fromrc(r[1],c[1]);
	return(0);
}


void outlineMoves(int on, int player)
{
	int i,r,c;
	SDL_Rect rect;

	for(i=0;i<121;i++)
		if(B[i] || m[0]==i)
		{
			torc(i,&r,&c);
			rect.x=CtoX(c)-2;
			rect.y=RtoY(r)-2;
			rect.w=selection->w;
			rect.h=selection->h;
			SDL_BlitSurface(oldwinbuf,&rect,s,&rect);
			if(on)
				SDL_BlitSurface(selection,NULL,s,&rect);
		}
	UpdateWin(0);
}

/*this is a recursive function to find all the jumps an mark them */
void Xfindalljumps(int curmove)
{
	int ct,p,j,r,c;

	for(ct=0;ct<6;ct++)
	{
		j=0;
		torc(curmove,&r,&c);
		switch(ct) /*the 6 possible directions are scanned*/
		 {
			 case 0 : p=fromrc(r+2,c+2); if(p>-1) j=b[fromrc(r+1,c+1)]; break;
			 case 1 : p=fromrc(r+2,c-2); if(p>-1) j=b[fromrc(r+1,c-1)]; break;
			 case 3 : p=fromrc(r  ,c+4); if(p>-1) j=b[fromrc(r  ,c+2)]; break;
			 case 2 : p=fromrc(r  ,c-4); if(p>-1) j=b[fromrc(r  ,c-2)]; break;
			 case 4 : p=fromrc(r-2,c+2); if(p>-1) j=b[fromrc(r-1,c+1)]; break;
			 case 5 : p=fromrc(r-2,c-2); if(p>-1) j=b[fromrc(r-1,c-1)]; break;
		 }
		if ( j && !b[p] && !B[p])
		{
			B[p]=1;
			Xfindalljumps(p);
		}
	}
}

/*checks for a valid slide distance*/
void Xallslides(int p)
{
	int i,j,r,c,q;
	
	torc(p,&r,&c);
	for(i=-1;i<2;i++)
		for(j=-2;j<3;j++)
		{
			q=fromrc(r+i,c+j);
			if(q>-1 && !b[q])
				B[q]=1;
		}
}

/*clear the status and error output from the screen*/
void Xclrerror()
{
	initmarbles();
}

/*print the translation of the status from the driver to the screen*/
void Xstatprint(int stat)
{
	texto_print(0,0,"Status:");
	text_print(0,text_height()+2,stat_str[stat]);
}

/*print the translation of the error status from the driver to the screen*/
void Xerrprint(int err)
{
	texto_print(0,text_height()*3,"Error:");
	text_print(0,text_height()*4+2,err_str[(err?12:0)]);
}
