#include "CC.h"

int legalmv (int plyr)	/*check and make move from movefile and to boardfile*/
{
int ct=1,r1,r2,c1,c2;

/*if not players piece - 1*/
if (b[m[0]]!=plyr) return(1);
/*if not a full movefile - 2*/
if (m[0]==-1 || m[1]==-1) return(2);
/*check a single step move for a slide*/
if (m[2]==-1)
{
	torc(m[0],&r1,&c1);
	torc(m[1],&r2,&c2);
	if ((r1==r2 && (c2==c1+2 || c2==c1-2)) || ((r2==r1+1 || r2==r1-1) && (c2==c1-1 || c2==c1+1)))
	{
		if (!b[m[1]])
		{
			/*valid move so now make it so*/
			b[m[ct]]=b[m[0]];
			b[m[0]]=0;
			return(0);
		}
/*if slide but destination is not empty - 3*/
		else return(3);
	}
}

/*check for valid jump*/
for (ct=0;m[ct+1]!=-1;ct++) /*trace jumps*/
{
	torc(m[ct],&r1,&c1);
	torc(m[ct+1],&r2,&c2);
/*if destination of one of the jumps is not empty - 4*/
	if (b[fromrc(r2,c2)]!=0) return(4);
/*if jump down left and no middle marble - 5*/
	if((r2==r1+2)&&(c2==c1-2)&&(b[fromrc(r1+1,c1-1)]==0))
		return(5);
/*if jump down right and no middle marble - 6*/
	if((r2==r1+2)&&(c2==c1+2)&&(b[fromrc(r1+1,c1+1)]==0))
		return(6);
/*if jump to right and no middle marble - 7*/
	if((r1==r2)&&(c2==c1+4)&&(b[fromrc(r1,c1+2)]==0))
		return(7);
/*if jump to left and no middle marble - 8*/
	if((r1==r2)&&(c2==c1-4)&&(b[fromrc(r1,c1-2)]==0))
		return(8);
/*if jump up left and no middle marble - 9*/
		if((r2==r1-2)&&(c2==c1-2)&&(b[fromrc(r1-1,c1-1)]==0))
			return(9);
/*if jump up right and no middle marble - 10*/
	if((r2==r1-2)&&(c2==c1+2)&&(b[fromrc(r1-1,c1+1)]==0))
			return(10);
/*if invalid jump distance - 11*/
	if (!(((r2==r1+2)&&(c2==c1-2))||((r2==r1+2)&&(c2==c1+2))||
		  ((r1==r2)&&(c2==c1+4))||((r1==r2)&&(c2==c1-4))||
		  ((r2==r1-2)&&(c2==c1-2))||((r2==r1-2)&&(c2==c1+2))))
		return(11);
}
/*valid move so now make it so*/
b[m[ct]]=b[m[0]];
b[m[0]]=0;

return(0);
}
