#include "CC.h"

int rots[6][6]=
{
	{0 },
	{3, 3},
	{2, 2, 2,},
	{1, 2, 1, 2},
	{1, 1, 2, 1, 1},
	{1, 1, 1, 1, 1, 1}
};
int positions[6][6]= /* the opposite of games */
{
	{0,-1,-1,-1,-1,-1},
	{0,-1,-1, 1,-1,-1},
	{0,-1, 1,-1, 2,-1},
	{0, 1,-1, 2, 3,-1},
	{0, 1, 2,-1, 3, 4},
	{0, 1, 2, 3, 4, 5}
};
int games[6][6]=
{
	{1               },
	{1,       4      },
	{1,    3,    5   },
	{1, 2,    4, 5   },
	{1, 2, 3,    5, 6},
	{1, 2, 3, 4, 5, 6}
};
char *stat_str[]=
{
	"Oops!",
	"Regular Turn\nMake A Move",
	"You Lost The Game",
	"You Won The Game",
	"Starting a New Game\nMake First Move",
	"You Made 1 Invalid Move\nTry Again",
	"You Made 2 Invalid Moves\nLast Try",
	"Player 1 Forfeited",
	"Player 2 Forfeited",
	"Player 3 Forfeited",
	"Player 4 Forfeited",
	"Player 5 Forfeited",
	"Player 6 Forfeited",
	"Time Delay Loss"
};
char *err_str[]=
{
	"No Error",
	"Not Your Player",
	"Incomplete Move",
	"Slide Destination\nNot Empty",
	"Jump Destination\nNot Empty",
	"No Jumper Marble\nOn Forward Left Jump",
	"No Jumper Marble\nOn Forward Right Jump",
	"No Jumper Marble\nOn Side Right Jump",
	"No Jumper Marble\nOn Side Left Jump",
	"No Jumper Marble\nOn Back Left Jump",
	"No Jumper Marble\nOn Back Right Jump",
	"Invalid Jump Distance",
	"Invalid Move"
};
int playerlist[6]={0, 0, -1, -1, -1, -1};		/* current players numbers */
int outcome;
int valid;
int min;
int temp;
int ANIM_LEN_V=350;		/* milliseconds for gui vertical jumping animation */
int ANIM_LEN_S=350;		/* milliseconds for gui sideways jumping animation */
//int ANIM_DLY_V=30;		/* delay to acheive FPS */
//int ANIM_DLY_S=30;		/* delay to acheive FPS */
int configured_players;	/* number of players configured in executable */
int numplayers;			/* number of current players in current game */
int m[100]={ -1, -1};	/* move buffer */
int b[121];				/* the board */
char o[17][50];			/* the last vt board */
BOOL quit=FALSE;		/* quit the game flag */
BOOL newgame;			/* newgame flag */
int view=FALSE;			/* use VT type UI */
int GUI=FALSE;			/* use GUI? */
int try;				/* player's number of tries for a valid move */
int status;				/* game status (see stat_str in data.c) */
int tempstatus;			/* win status */
int player_err;			/* player error from legalmv (see err_str in data.c) */
int crash;				/* crashed player number in game, too many invalid moves */
int win;				/* winning player number in game */
int player;				/* player number in game */
int plyr;				/* index in playerlist */
int *Argc;				/* pointer to argc */
char **Argv;			/* argv */
BOOL autoexit;			/* exit immeadiatly after game */
