#include "CC.h"

int fromrc (int row, int col)
{
/*the left edge of the board in integer format*/
int leftedge[17]={0,1,3,6,10,23,35,46,56,65,75,86,98,111,115,118,120};

/*the left at right edges of the board in row/column format*/
int leftcol[17]={13,12,11,10,1,2,3,4,5,4,3,2,1,10,11,12,13};
int rightcol[17]={13,14,15,16,25,24,23,22,21,22,23,24,25,16,15,14,13};

/*checks to see if the row and column are inbounds (square)*/
if (row<1 || row>17 || col<1 || col>25) return(-1);

/*checks to see if the row and column are on the board.*/
if (leftcol[row-1]>col || rightcol[row-1]<col) return(-1);

/*  checks to see if row and column are the same mod. 
    e.g. - even row numbers always have even column numbers */
if (row%2 != col%2) return(-1);

return (leftedge[row-1]+((col-leftcol[row-1])/2));
}
