#include "CC.h"

BOOL GP_done;
char **player_cyc[6];

int do_gp_done()
{
	int ct,i,j;

	ct=0;
	for(i=0;i<6;i++)
		if(playerlist[i]>-1)
			ct++;
	if(ct>1)
	{
		// Compress player array
		i=j=0;
		while(j<6)
		{
			while(playerlist[i]>-1 && i<5)
				i++;
			for(j=i+1;playerlist[j]==-1 && j<6;j++);
			if(i<5 && j<6)
			{
				playerlist[i]=playerlist[j];
				playerlist[j]= -1;
			}
		}
		GP_done=TRUE;
		done=TRUE;
	}
	return(1);
}

int do_getplayers()
{
	int i;

	for(i=0;i<6 && hotspot->button->data!=player_cyc[i];i++);
	if(i<6)
		playerlist[i]=hotspot->state-1;
	return(1);
}

int getplayers()
{
	int i,j,h,w,max_w,x,y,ww,X,Y,W,H;
	char **cyc, str[2];
	Buttons player_buttons[6];
	Uint32 black;

	//errr("gp.log",NULL);
	GP_done=FALSE;
	newgame=FALSE;
	black=SDL_MapRGB(s->format,0,0,0);
	//SDL_BlitSurface(ccboard,NULL,s,NULL);
	SDL_FillRect(s,NULL,black);

	//errr("gp.log","malloc cyc\n");
	cyc=(char**)malloc(sizeof(char*)*(configured_players+2));
	//errr("gp.log","cyc[0]=none\n");
	cyc[0]="None";
	cyc[configured_players+1]=NULL;
	//errr("gp.log","cyc=player name loop\n");
	for(i=0;i<configured_players;i++)
		cyc[i+1]=players[i].name;
	//errr("gp.log","button create loop\n");
	for(i=0;i<6;i++)
	{
		player_cyc[i]=(char**)malloc(sizeof(char*)*(configured_players+2));
		//errr("gp.log","player_cyc create loop\n");
		for(j=0;j<configured_players+2;j++)
			player_cyc[i][j]=cyc[j];
		//errr("gp.log","player_cyc created\n");
		player_buttons[i].type=BU_CYCLE;
		player_buttons[i].data=player_cyc[i];
		player_buttons[i].func=do_getplayers;
	}
	//errr("gp.log","find max num width\n");
	max_w=0;
	str[1]=0;
	for(i=1;i<6;i++)
	{
		str[0]=i+'0';
		w=JASDLFont_Width(font,str);
		if(w>max_w)
			max_w=w;
	}
	//errr("gp.log","size buttons\n");
	SizeButtons(BU_V, 6, player_buttons,&w,&h);
	SizeButtons(BU_H, 2, GP_buttons,&i,&j);
	if(i>w+max_w)
		ww=i;
	else
		ww=w+max_w;
	x=ccboard->w/2-ww/2;
	y=ccboard->h/2-(h+j+EDGE+text_height()+7)/2;
	X=x-EDGE;
	Y=y;
	W=ww+EDGE*2;
	H=j+h+EDGE*2+text_height()*3+11;
	DrawGadgetBox(X,Y,W,H);
	textoc_print(0,y,ccboard->w,"Chinese");
	y+=text_height();
	textoc_print(0,y,ccboard->w,"Checkers");
	y+=text_height()+4;
	textoc_print(0,y,ccboard->w,"Players");
	y+=text_height()+4;
	//DrawInvGadgetBox(x+2,y,ww-4,2);
	y+=4;
	for(i=0;i<6;i++)
	{
		int tw;
		str[0]=i+'1';
		tw=x+EDGE;
		tw+=text_print(tw,y+(text_height()+EDGE*2)*i+EDGE,str)+20;
		PutMarble(i,tw,y+(text_height()+EDGE*2)*i+EDGE);
	}
	DrawButtons(BU_V,6,player_buttons,x+ww-w-EDGE,y);
	DrawButtons(BU_H,2,GP_buttons,x,y+h+EDGE);
	for(i=0;i<6;i++)
		set_hotspot_state(player_cyc[i], playerlist[i]+1);

	{
		float A=0,a;
		SDL_Rect rect={X-EDGE,Y-EDGE,W+EDGE*2,H+EDGE*2};
		SDL_BlitSurface(s,&rect,winbuf,&rect);
	
		while(!GP_done && !quit)
		{
			if(!Mix_PlayingMusic())
				Mix_PlayMusic(music[1],-1);
			SDL_FillRect(s,NULL,black);
			for(a=0,i=W/2-16;i<s->h;i+=3)
			{
				a=fmod(a+A,360*RADIAN);
				x=cos(a)*i+s->w/2;
				y=sin(a)*i+s->h/2;
				PutMarble((i/3)%6,x,y);

				x=cos(a+90*RADIAN)*i+s->w/2;
				y=sin(a+90*RADIAN)*i+s->h/2;
				PutMarble((i/3)%6,x,y);

				x=cos(a+180*RADIAN)*i+s->w/2;
				y=sin(a+180*RADIAN)*i+s->h/2;
				PutMarble((i/3)%6,x,y);

				x=cos(a+270*RADIAN)*i+s->w/2;
				y=sin(a+270*RADIAN)*i+s->h/2;
				PutMarble((i/3)%6,x,y);
			}
			A+=RADIAN/10;
			if(A>=180*RADIAN)
				A=0;
			SDL_BlitSurface(winbuf,&rect,s,&rect);
			UpdateWin(0);
			JASDL_EventPollLoop();
			SDL_BlitSurface(s,&rect,winbuf,&rect);
		}
	}
		
	free_hotspots();
	for(i=j=0;i<6;i++)
		if(playerlist[i]>-1)
			j++;
	for(i=0;i<6;i++)
		free(player_cyc[i]);
	/*free(cyc[i]);*/ /*This was a bad idea, since I don't malloc anything!*/
	return(j); 										/* return # of players */
}
