#include "CC.h"

void dropMarble(int p, int x, int y)
{
	SDL_Rect r={x,0,ccmarble[p]->w,ccmarble[p]->h};
	float i,a;
	
	for(i=1,a=1;i<y;a*=1.2,i+=a)
	{
		PutMarble(p,x,i);
		UpdateWin(0);
		r.y=i;
		SDL_BlitSurface(ccboard,&r,s,&r);
	}
	playsound(5);
	PutMarble(p,x,y);
}

void initmarbles()
{
	int w,i,th,max_y,r,c,h;
	SDL_Rect rect={0,0,0,0};
	
	Mix_FadeOutMusic(3000);
	i=0;
	do {
		rect.y=i-s->h;
		SDL_BlitSurface(ccboard,NULL,s,&rect);
		UpdateWin(0);
		i+=10;
	} while(i<s->h);
	SDL_BlitSurface(ccboard,NULL,s,NULL);
	w=0;//JASDLFont_Width(font,"Players")+2;
	for(i=0;i<numplayers;i++)
	{
		r=JASDLFont_Width(font,players[playerlist[i]].name)+MARBLE_W;
		if(r>w)
			w=r;
	}

	th=JASDLFont_Height(font);
	max_y=th*(numplayers/*+1*/)+2+3;

	for(i=120;i>-1;i--)
		if(b[i])
		{
			torc(i,&r,&c);
			dropMarble(b[i]-1,CtoX(c),RtoY(r));
		}

	DrawGadgetBox(s->w-w-EDGE, -EDGE, w+EDGE, max_y);
	//JASDLFont_puts(font,s->w-w,0,"Players");
	for(i=0;i<numplayers;i++)
	{
		PutMarble(games[numplayers-1][i]-1,s->w-w,th*(i/*+1*/)+2);
		JASDLFont_puts(font,s->w-w+MARBLE_W,th*(i/*+1*/)+2,players[playerlist[i]].name);
	}

	SizeButtons(BU_V,2,option_buttons,NULL,&h);
	DrawButtons(BU_V,2,game_buttons,0,ccboard->h-h);
	SizeButtons(BU_V,2,option_buttons,&w,&h);
	DrawButtons(BU_V,2,option_buttons,ccboard->w-w,ccboard->h-h);
	UpdateWin(0);
	set_hotspot_state(hint_cyc, hints);
	set_hotspot_state(anim_cyc, animation);
	//set_hotspot_state(zoom_cyc, zoom);
}
