//#include <dlfcn.h>
#include <ltdl.h>
#include "CC.h"
#include "players.h"

//#define CMD_STR "/bin/ls -1 *.so | cut -d . -f1"

char *dataFName(char *str);

PlayerState ps;

void strip(char *str)
{
	while(str[strlen(str)-1]=='\n')
		str[strlen(str)-1]=0;
}

void loadplayers()
{
	char str[1024], cwd[1024], *libdir, sofname[4096];
	const char *p;
	FILE *f;
	Players *player;
	//void *handle;
	lt_dlhandle handle;

	lt_dlinit();
	//LTDL_SET_PRELOADED_SYMBOLS();
	
	ps.stat_str=stat_str;
	ps.err_str=err_str;
	ps.errr=errr;
	ps.fromrc=fromrc;
	ps.torc=torc;
	
	players=&humanplayer;
	players=(Players*)malloc(sizeof(Players)*2);
	memcpy(players,&humanplayer,sizeof(Players));
	configured_players=1;

	libdir=dataFName("players/players.txt");
	if((p=strrchr(libdir,'/')))
		*(char*)p='\0';
	fprintf(stderr,"Loading Players from \"%s\"\n",libdir);
	//if(!chdir(libdir))
	//{
		lt_dlsetsearchpath(libdir);
		if(p)
			*(char*)p='/';
		f=fopen(libdir,"r");
		if(f)
		{
			while(fgets(str,1024,f))
			{
				strip(str);
				//sprintf(sofname,"%s/%s",libdir,str);
				//handle=dlopen(sofname, RTLD_NOW);
				handle=lt_dlopenext(str);
				if(!handle)
					//fprintf(stderr,"dlopen(%s): %s\n",sofname,dlerror());
					fprintf(stderr,"lt_dlopenext(%s): %s\n",str,lt_dlerror());
				else
				{
					players=(Players*)realloc(players,sizeof(Players)*(configured_players+2));
					player=&players[configured_players];
					//player->name=(char*)dlsym(handle,"name");
					player->name=(char*)lt_dlsym(handle,"name");
					//if((p=dlerror()))
					if(!player->name)
					{
						//fprintf(stderr,"dlsym(%s,\"name\"):%s\n",sofname,p);
						fprintf(stderr,"lt_dlsym(%s,\"name\"):%s\n",str,p);
						player->name=NULL;
					}
					else
					{
						player->name=*(char**)player->name;
						//player->player_move_func=(PlayerMoveFunc)dlsym(handle,"move");
						player->player_move_func=(PlayerMoveFunc)lt_dlsym(handle,"move");
						//if((p=dlerror()))
						if(!player->player_move_func)
						{
							//fprintf(stderr,"dlsym(%s,\"move\"):%s\n",sofname,p);
							fprintf(stderr,"lt_dlsym(%s,\"move\"):%s\n",str,p);
							player->name=NULL;
						}
						else
						{
							printf("Loaded Player: %s move=%p\n",player->name,player->player_move_func);
							configured_players++;
						}
					}
				}
			}
			fclose(f);
		}
		else
			//perror(CMD_STR);
			perror(libdir);
	//	chdir(cwd);
	//}
	//else
	//	perror(libdir);
	players[configured_players].name=NULL;
}
