/* Show boardfile on a vt terminal */
#include "CC.h"

char o[17][50];

void printc(char str[50]) /*print by character and in color of player number*/
{
	int ct;

	for(ct=0;ct<strlen(str);ct++)
		if ((str[ct]>='0')&&(str[ct]<='6')) 
		{
			if (str[ct]=='0')
				printf ("\33[38;0m%c\33[38;0m",183); /*bright black*/
			else
				printf ("\33[3%cm%c\33[38;0m",str[ct],str[ct]);
		}
		else
			printf ("%c",str[ct]);
	printf("\n");
}

/* the main view board routine, draws board to screen as needed
 * status: 0 = redraw only as needed
 *         1 = redraw all
 *         2 = clear and redraw all
 */
int vb(int status) 
{
	char str[256];
	int ct,ct2,s;
	int  bf=0, of=0;

	if (status>0) 
	{
		if (status>1)
			printf("\33[2J\n"); /* clear screen */
		for (ct=0; ct<17; ct++) /* clear buffered board to force redraw */
			memset(o[ct],0,50);
	}
/*Proccesses the board in 4 sections*/
	for (ct=1;ct<=4;ct++)
	{
		for(ct2=0;ct2<ct;ct2++)
		{
			str[ct2*2]=b[bf++]+48;
			str[ct2*2+1]=' ';
		}
		str[ct2*2-1]=0;
		s=13-((strlen(str)-1)/2);
		if (strncmp(str,o[of]/*str2*/,strlen(str))!=0)
		{
			printf("\33[%d;%df",ct,27+s);
			printc(str);
			strcpy(o[of++], str);
		}
	}
	for (ct=5;ct<=9;ct++)
	{
		for(ct2=0;ct2<18-ct;ct2++)
		{
			str[ct2*2]=b[bf++]+48;
			str[ct2*2+1]=' ';
		}
		str[ct2*2-1]=0;
		s=13-((strlen(str)-1)/2);
		if (strncmp(str,o[of]/*str2*/,strlen(str))!=0)
		{
			printf("\33[%d;%df",ct,27+s);
			printc(str);
			strcpy(o[of++], str);
		}
	}
	for (ct=10;ct<=13;ct++)
	{
		for(ct2=0;ct2<ct;ct2++)
		{
			str[ct2*2]=b[bf++]+48;
			str[ct2*2+1]=' ';
		}
		str[ct2*2-1]=0;
		s=13-((strlen(str)-1)/2);
		if (strncmp(str,o[of]/*str2*/,strlen(str))!=0)
		{
			printf("\33[%d;%df",ct,27+s);
			printc(str);
			strcpy(o[of++], str);
		}
	}
	for (ct=14;ct<=17;ct++)
	{
		for(ct2=0;ct2<18-ct;ct2++)
		{
			str[ct2*2]=b[bf++]+48;
			str[ct2*2+1]=' ';
		}
		str[ct2*2-1]=0;
		s=13-((strlen(str)-1)/2);
		if (strncmp(str,o[of]/*str2*/,strlen(str))!=0)
		{
			printf("\33[%d;%df",ct,27+s);
			printc(str);
			strcpy(o[of++], str);
		}
	}
	printf ("\33[20;1f\n"); /*go to bottom of screen*/
	return(0);
}
